#pragma once

#include "aicomponent.h"

enum AndroidState_e
{
   AS_thinking,
   AS_moving,
   AS_attack,
};

class Human;
class AndroidAI : public AIComponent
{
 public:
    virtual ~AndroidAI() override;
    virtual void Update(int delta_time) override;

    void LockEnemy(Human* enemy);
    void LockEnemy(int target_id);
    void UnLockEnemy();

private:
    AndroidState_e state_ = AS_thinking;
    int state_elapsed_time_ = 0;

    Human* HumMaster();
    void ChangeToState(AndroidState_e to_state);

    void DoMove();
    void DoAttack();

    void Shot(Human* enemy);
    void UseSkill(Human* enemy);

    Human* locked_enemy_ = nullptr;
    long long locked_frameno_ = 0;
};
