#include "precompile.h"

#include "android.h"
#include "metamgr.h"
#include "android.ai.h"
#include "room.h"
#include "app.h"

#include "framework/cpp/utils.h"

Android::Android():Human()
{
    entity_type = kET_Player;
    entity_subtype = kEST_Android;
    ai = new AndroidAI;
    ai->owner = this;
    ++App::Instance()->perf.entity_num[kET_Android];
}

Android::~Android()
{
    delete ai;
    ai = nullptr;
    --App::Instance()->perf.entity_num[kET_Android];
}

void Android::Initialize()
{
    Human::Initialize();
    SetTankInfo(MetaMgr::Instance()->RandTank());
    if (!f8::IsOnlineEnv() && !room->test_params.empty() && room->test_params[0] > 0) {
        tank_.tank_lv = room->test_params[0];
    }
    tank_meta_ = MetaMgr::Instance()->GetTank(TankId());
    if (tank_meta_) {
        skill_meta_ = MetaMgr::Instance()->GetSkill(tank_meta_->i->skill_id());
        skill_lv_ = TankLv();
    }
    GiveEquip();
    MetaData::TankSkin* tank_tank_meta = MetaMgr::Instance()->GetTankSkin(TankId());
    if (tank_tank_meta) {
        tankskin.skin_id = tank_tank_meta->i->tank_id();
        tankskin.skin_lv = 1;
    }
    RecalcBaseAttr();
}

void Android::Update(int delta_time)
{
    if (action_type != kAT_None) {
        UpdateAction();
    }
    ai->Update(delta_time);
}

void Android::GiveEquip()
{
    if (tank_meta_) {
        MetaData::Equip* weapon_meta = MetaMgr::Instance()->GetEquip(tank_meta_->i->bullet_id());
        if (weapon_meta) {
            weapons[kGUN_SLOT1].weapon_idx = kGUN_SLOT1;
            #if 1
            weapons[kGUN_SLOT1].weapon_id = weapon_meta->i->id();
            weapons[kGUN_SLOT1].weapon_lv = rand() % 3;
            #else
            weapons[kGUN_SLOT1].weapon_id = weapon_meta->i->id();
            weapons[kGUN_SLOT1].weapon_lv = robot_meta->i->weapon_lv();
            #endif
            weapons[kGUN_SLOT1].ammo = 0;
            weapons[kGUN_SLOT1].meta = weapon_meta;
            weapons[kGUN_SLOT1].Recalc();
            curr_weapon = &weapons[kGUN_SLOT1];
            DirectReload();
        }
    }
}
