#pragma once

#include "entity.h"

namespace MetaData
{
    struct Equip;
}

class Human;
class Bullet : public Entity
{
 public:
    MetaData::Equip* meta = nullptr;
    Human* master = nullptr;
    a8::Vec2 dir;
    a8::Vec2 born_pos;
    a8::Vec2 born_dir;
    float fly_distance = 0.0f;
    int skill_id = 0;

    Bullet();
    virtual ~Bullet() override;
    virtual void Initialize() override;
    virtual void Update(int delta_time) override;

    static void ProcMissible(const a8::XParams& param);

 private:

    void OnHit(std::set<Entity*>& objects);
    void PostAttack();

private:
    std::set<Human*> hited_humans_;
};
