#pragma once

enum SocketFrom_e
{
    kSFGameGate,
};

enum InnerMesssage_e
{
    kIM_ClientSocketDisconnect  = 100,
    kIM_PlayerOffline,
    kIM_ExecGM,
    kIM_DBSConnDisconnect,
    kIM_BSConnDisconnect,
    kIM_LoadConfig,
    kIM_HttpResponse,
};

//网络处理对象
enum NetHandler_e
{
    HID_Player,
    HID_PlayerMgr,
    HID_Room,
    HID_RoomMgr,
    HID_GGListener,
};

enum DoorState_e
{
    kDoorStateClose = 0,
    kDoorStateOpen = 1
};

enum GasMode_e
{
    kGasInactive = 0,
    kGasStarted = 1,
};

enum ActionType_e
{
    kAT_None = 0,
    kAT_Reload = 1,
    kAT_UseItem = 2,
};

enum InventorySlot_e
{
    kIS_9MM  = 0,
    kIS_556MM  = 1,
    kIS_762MM  = 2,
    kIS_12GAUGE  = 3,
    kIS_RPG  = 4,
    kIS_FRAG  = 5,
    kIS_SMOKE  = 6,
    kIS_HEALTHKIT  = 7,
    kIS_PAIN_KILLER  = 8,
    kIS_TANK = 9,

    kIS_1XSCOPE  = 12,
    kIS_2XSCOPE  = 13,
    kIS_4XSCOPE  = 14,
    kIS_8XSCOPE  = 15,
    kIS_15XSCOPE = 16,

    kIS_END
};

enum SkillCond_e
{
    kSC_Active = 1,
    kSC_Passive = 2
};

enum VirtualWeapon_e
{
    kVW_Spectate = 9000001,
    kVW_SelfDetonate = 9000002,
    kVW_Mine = 9000003,
};

enum VirtualPlayer_e
{
    kVP_Spectate = 9000001,
    kVP_SelfDetonate = 9000002,
    kVP_Mine = 9000003,
};

enum EntityType_e
{
   kET_None = 0,
   kET_Player = 1,
   kET_Obstacle = 2,
   kET_Building = 3,
   //kET_LootSpawner = 4,
   kET_Loot = 5,
   //ET_DeadBody = 6,
   //ET_Decal = 7,
   //ET_Projectile = 8,
   kET_Smoke = 9,
   kET_Hero = 10,

   kET_Bullet = 20,

   kET_Android = 30,
   kET_MAX
};

enum EntitySubType_e
{
   kEST_None = 0,
   kEST_Player = 1,
   kEST_Android = 2,
};

enum SkillTarget_e
{
   kST_All = 0,

   kST_Self = 1,
   kST_FriendlyIncludeSelf = 2,
   kST_FriendlyExcludeSelf = 3,

   kST_EnemySingle = 6,
   kST_EnemyGroup = 7,
   kST_EnemyAndObject = 8,
   kST_EnemyAndSelf = 9,
   kST_SingleEnemyAndSelf = 10
};

enum BuffTriggerType_e
{
    kBTT_UseSkill = 1, //技能释放时触发
    kBTT_Kill = 2, //击杀敌方后触发
    kBTT_SkillHit = 3, //技能命中触发
    kBTT_OtherBuff = 4,//其他buff触发
    kBTT_UseItem = 6   //使用道具触发
};

enum BuffTargetType_e
{
    kBuffTargetSelf = 1, //自己
    kBuffTargetFriendly = 2, //友军
    kBuffTargetEnemy = 3, //敌军
};

enum BuffEffectType_e
{
    kBET_Begin = 0,
    kBET_ChgAttr = 1, //改变属性
    kBET_Vertigo = 2, //眩晕
    kBET_InGrass = 3, //在草丛
    kBET_LastBurn = 4, //持续灼烧
    kBET_Invincible = 5, //无敌
    kBET_Hide = 6, //隐身
    kBET_Dcgr = 7, //电磁干扰
    kBET_ReleaseDcgr = 8, //释放电磁干扰
    kBET_ReleaseFireBomb = 9, //喷火
    kBET_Assault = 10, //向心突击
    kBET_OnceChgAttr = 11, //一次性buff
    kBET_LastRecover = 12, //持续回血
    kBET_Shield = 13, //护盾
    kBET_ImmediatelyRevive = 14, //立刻复活
    kBET_End
};

enum SkillFunc_e
{
    kSkill_FuncNone = 0,
    kSkill_Jump = 2,
    kSkill_Shot = 3,
    kSkill_SummonObject = 4,
    kSkill_FuncEnd
};

enum HumanAttrType_e
{
    kHAT_Begin = 0,
    kHAT_Hp = 1,
    kHAT_HPRecover = 2,
    kHAT_Atk = 3,
    kHAT_Def = 4,
    kHAT_Speed = 5,
    kHAT_ShotRange = 6,
    kHAT_ShotSpeed = 7,
    kHAT_ReloadSpeed = 8,
    kHAT_FireRate = 9,
    kHAT_End
};

enum EquipType_e
{
    kEquipType_Bullet = 1,
    kEquipType_Buff = 3,
};

enum BulletType_e
{
    kBulletType_Normal = 1, //普通子弹
    kBulletType_Missile = 2, //导弹
    kBulletType_FireBomb = 3, //燃烧弹
    kBulletType_Trace = 4, //追踪弹（超出射程无伤害）
};

enum ColliderTag_e
{
    kColliderTag_Grass = 1, //草丛
    kColliderTag_Loot = 2, //掉落物
};

enum PropertyType_e
{
    kPropHp = 1,
    kPropMaxHp = 2,
    kPropInventory = 3,
    kPropSkillLeftTime = 4,
    kPropSkillCd = 5
};

const char* const kPROJ_NAME_FMT = "game%d_gameserver";
const char* const kPROJ_ROOT_FMT = "/data/logs/%s";

const float kTEN_W = 10000 * 10;

const int kSYS_RESET_TIME = 2*60; //每日两点重置

const int kDEF_WEAPON_ID = 12103;

const int kSERVER_FRAME_RATE = 20;
const int kSYNC_FRAME_RATE = 10;
const float kFRAME_RATE_MS = 1000.0f / kSERVER_FRAME_RATE;

const int kMAX_WEAPON_NUM = 5;
const int kMAX_SKIN_LV = 9;

const int kGUN_SLOT0 = 0;
const int kGUN_SLOT1 = 1;
const int kGUN_SLOT2 = 2;

const int kFRAG_SLOT = 3;
const int kSMOKE_SLOT = 4;

const int kMAP_CELL_WIDTH = 64 * 8;
const int kMAP_GRID_WIDTH = 64;

const int kDOOR_THING_ID = 61701;

const int kFIGHTING_MODE_BULLET_NUM = 10000 * 10000;

const int kMAX_NODE_ID = 8;
const int kMAX_INSTANCE_ID = 500;

const int kMAX_TEAM_NUM = 4;

const int kWEAPON_SLOT = 0;

const int kROOM_MAX_PLAYER_NUM = 10;

const int kFIRE_WALL_EQUIP_ID = 61401;

const int kMAX_SYS_HTTP_NUM = 2;
const int kMAX_USER_HTTP_NUM = 8;
const int kMAX_ALL_HTTP_NUM = kMAX_SYS_HTTP_NUM + kMAX_USER_HTTP_NUM;

