#pragma once

#include "cs_proto.pb.h"

class Bullet;
class Human;
class Buff;
class Room;
struct FrameEvent
{
public:
    Room* room = nullptr;

public:
    void AddAirDrop(int appear_time, std::vector<a8::Vec2>& pos_list);
    void AddEmote(Human* hum, int emote_id);
    void AddShot(Human* hum);
    void AddBullet(Human* hum, int bullet_id, int bullet_lv, a8::Vec2 born_pos, a8::Vec2 dir,
                   float fly_distance, int hit_time, int target_id = 0, int skill_id = 0);
    void AddExplosion(int item_id, a8::Vec2 bomb_pos, int effect);
    void AddSmoke(Bullet* bullet, int item_id, a8::Vec2 pos);
    void AddDead(Human* hum, int revive_time);
    void AddRevive(Human* hum);
    void AddBuff(Human* hum, Buff* buff);
    void RemoveBuff(Human* hum, int buff_id);
    void AddHpChg(Human* hum);
    void AddInventoryChg(Human* hum);
    void AddSkillCdChg(Human* hum);

    void Clear();
private:
    ::google::protobuf::RepeatedPtrField<::cs::MFAirDrop> airdrops_;
    std::vector<std::tuple<Human*, ::cs::MFShot>> shots_;
    std::vector<std::tuple<Human*, ::cs::MFBullet>> bullets_;
    std::vector<::cs::MFExplosion> explosions_;
    std::vector<std::tuple<Human*, ::cs::MFSmoke>> smokes_;
    std::vector<std::tuple<Human*, ::cs::MFEmote>> emotes_;
    std::vector<std::tuple<Human*, ::cs::MFBuffChg>> chged_buffs_;
    std::vector<int> revive_objs_;
    std::vector<std::tuple<int, int>> dead_objs_;
    std::vector<Human*> chged_hps_;
    std::vector<Human*> chged_inventorys_;
    std::vector<Human*> chged_skillcds_;

    friend class FrameMaker;
};
