#include "precompile.h"
#include "global.h"
#include "app.h"

#include "framework/cpp/utils.h"

int Global::g_nowtime = time(nullptr);
int Global::g_time_zone = 8;
bool Global::g_shutdown = false;
ColliderComponent* Global::last_collider = nullptr;

bool IsValidSlotId(int slot_id)
{
    return slot_id >= 0 && slot_id < kIS_END;
}

bool IsValidBuffEffect(int buff_effect)
{
    return buff_effect > kBET_Begin && buff_effect < kBET_End;
}

bool IsValidHumanAttr(int attr_type)
{
    return attr_type > kHAT_Begin && attr_type < kHAT_End;
}

std::string GetResDir()
{
    std::string res_path;
    if (!f8::IsOnlineEnv()) {
        if (App::Instance()->HasFlag(2)) {
            res_path = a8::Format("/root/pub/%d/%d/conf_test/game%d/gameserver/res/",
                                  {
                                   GAME_ID,
                                   App::Instance()->instance_id,
                                   GAME_ID
                                  });
        } else {
            res_path = a8::Format("/var/data/conf_test/game%d/gameserver/res/", {GAME_ID});
        }
    } else {
        res_path = "../res/";
    }
    return res_path;
}
